<template>
	<div :id="`map-${random}`" class="map"></div>
</template>

<script lang="ts">
import { defineComponent, ref, onMounted, onUnmounted, watch, SetupContext, Ref, toRefs } from '@vue/composition-api';
import 'mapbox-gl/dist/mapbox-gl.css';
import {
	createMap,
	createControls,
	addLayers,
	addControls,
	ControlTypes,
	addEventHandlers,
	MapEventHandler,
	loadIcons,
} from '@/components/map/mglUtils';
import { MarkerConfig } from '@/store/modules/fieldsView/utils';
import { Map as MapboxMap, Control, Layer, EventData, GeoJSONSource, Marker, Popup } from 'mapbox-gl';
import config from '@/configuration';
import { markerInstances, clearMarkerInstances, MarkerInstances } from './MglMap';

const addMarkers = (map: MapboxMap, markers: MarkerConfig[], markerInstances: MarkerInstances) => {
	markers.forEach((markerConfig) => {
		const popup = new Popup({
			closeButton: false,
			maxWidth: '300px',
		}).setHTML(markerConfig.html);

		const marker = new Marker()
			.setLngLat(markerConfig.lngLat as [number, number])
			.setPopup(popup)
			.addTo(map);

		markerInstances[markerConfig.id] = marker;
	});
};

const updateMarkers = (map: MapboxMap, markerInstances: MarkerInstances) => (
	markers: MarkerConfig[],
	prevMarkers: MarkerConfig[]
) => {
	const markerIds = markers.map((marker) => marker.id);
	const prevMarkerIds = prevMarkers.map((prevMarker) => prevMarker.id);
	const markerIdsToRemove = prevMarkerIds.filter((prevMarkerId) => !markerIds.includes(prevMarkerId));

	const markersToAdd = markers.filter(({ id }) => !prevMarkerIds.includes(id));

	markerIdsToRemove.forEach((markerId) => {
		const marker = markerInstances[markerId];
		marker.remove();
		delete markerInstances[markerId];
	});

	addMarkers(map, markersToAdd, markerInstances);
};

const updateLayers = (map: MapboxMap) => (layers: Layer[], prevLayers: Layer[]) => {
	const layerIdsToRemove = prevLayers
		.map((prevLayer) => prevLayer.id)
		.filter((prevLayerId) => !layers.some((layer) => layer.id === prevLayerId));

	layerIdsToRemove.forEach((id) => {
		map.removeLayer(id);
		map.removeSource(id);
	});

	layers &&
		layers.forEach((layer: Layer) => {
			if (map.getLayer(layer.id)) {
				// eslint-disable-next-line @typescript-eslint/no-explicit-any
				const source = layer?.source as GeoJSONSource & { data: any };
				source && (map.getSource(layer.id) as any).setData(source.data);
			} else {
				map.addLayer(layer);
			}
		});
};

export default defineComponent({
	props: {
		markers: {
			type: Array as () => MarkerConfig[],
		},
		layers: {
			type: Array as () => Layer[],
		},
		controls: {
			type: Array as () => ControlTypes[],
		},
		eventHandlers: {
			type: Array as () => Array<(emit: SetupContext['emit']) => MapEventHandler>,
			default: () => [],
		},
		bounds: {
			default: null,
		},
		fitBoundsOptions: {
			// eslint-disable-next-line @typescript-eslint/no-explicit-any
			type: Object as () => undefined | null | { [key: string]: any },
		},
		zoom: {
			type: Number,
		},
		center: {
			type: Array,
		},
		maxBounds: {
			type: Array, // LngLatBoundsLike
		},
		tileset: {
			type: String,
			default: config.mapbox.tileset,
		},
	},
	setup(props, { emit }) {
		const map = ref();
		const mapControls: Ref<{ [key: string]: Control }> = ref({});
		const random = Math.floor(Math.random() * 1e6);

		onMounted(() => {
			map.value = createMap({
				container: `map-${random}`,
				accessToken: process.env.VUE_APP_MAPBOX_TOKEN,
				center: props.center,
				maxBounds: props.maxBounds || null,
				zoom: props.zoom,
				tileset: props.tileset,
			});

			map.value.on('load', () => {
				if (props.markers?.length) {
					addMarkers(map.value, props.markers, markerInstances);
				}
				loadIcons(map.value);
				if (props.layers?.length) {
					addLayers(map.value, props.layers);
				}
				if (props.controls) {
					mapControls.value = createControls(props.controls);
					addControls(map.value, mapControls.value);
					if (ControlTypes.Geolocate in mapControls.value) {
						mapControls.value[ControlTypes.Geolocate].on('trackuserlocationstart', () => {
							emit('trackUserLocationStart');
						});
						mapControls.value[ControlTypes.Geolocate].on('trackuserlocationend', (ev: EventData) => {
							if (ev.target._watchState === 'OFF') {
								// 'trackuserlocationend' gets emitted by MapboxGL when user pans map,
								// and in other situations. Let's only fire our event when user turns off GPS.
								emit('trackUserLocationEnd');
							}
						});
					}
				}
				const propsRef = toRefs(props);
				const layersRef = propsRef.layers;
				const markersRef = propsRef.markers;
				layersRef?.value && watch(layersRef as Ref, updateLayers(map.value));
				markersRef?.value && watch(markersRef as Ref, updateMarkers(map.value, markerInstances));
			});

			if (props.eventHandlers?.length) {
				addEventHandlers(emit, map.value, props.eventHandlers);
			}
		});

		onUnmounted(clearMarkerInstances);

		return {
			map,
			mapControls,
			random,
		};
	},
});
</script>

<style scoped>
.map {
	height: 60vh;
}

.mapboxgl-popup-content {
	padding: 10px !important;
}
</style>
